//_____ I N C L U D E S ________________________________________________________
//#include "compiler.h"
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>

//user defined
//#include "header.h"
#include "font_8x8.h"
#include "lcd.h"

extern unsigned char bitmap[160*20];

#define lcd_delay 100	//30534 - old

void * memcpy_Pinv(void * start1, PGM_VOID_P start2, size_t nbytes){

	uint8_t *p1 = (uint8_t*)start1;
	uint8_t *p2 = (uint8_t*)start2;
	unsigned char tmp;
	while(nbytes--) {
		memcpy_P(&tmp,start2++,1);//*p1++ = (uint8_t)(~*p2++);
		tmp=~tmp;
		memcpy(start1++,&tmp,1);
	}
}

// Init LCD Controler
void InitLCD() 
{
  
  //IO0CLR_bit.P0_21 = 1;  // CP to low - use OC1C pin output for this purpose
  PORTA = PORTA & ~(1<<PA6);   // DOFF to low
  PORTA = PORTA & ~(1<<PA7);   // VHH to low
  PORTA = PORTA & ~(1<<PA5);  // LP to low
  PORTA = PORTA & ~(1<<PA4);  // FLM to low
  PORTA = PORTA & ~(1<<PA3);  // D3 to low
  PORTA = PORTA & ~(1<<PA2);  // D2 to low
  PORTA = PORTA & ~(1<<PA1);  // D1 to low
  PORTA = PORTA & ~(1<<PA0);  // D0 to low
	
  PORTC = PORTC & ~(1<<PC6);  // backlight_enable to low	
  //IO0CLR_bit.P0_25 = 1;  // EL2 to low
  //IO0CLR_bit.P0_23 = 1;  // EL1 to low
  
  DDRB = DDRB | 1<<DDB7;  // CP as output
 /* DDRA = DDRA | 1<<DDA6;   // DOFF as output
  DDRA = DDRA | 1<<DDA7;   // VHH as output
  DDRA = DDRA | 1<<DDA5;  // LP as output
  DDRA = DDRA | 1<<DDA4;    // FLM as output
  DDRA = DDRA | 1<<DDA3;  // D3 as output
  DDRA = DDRA | 1<<DDA2;  // D2 as output
  DDRA = DDRA | 1<<DDA1;  // D1 as output
  DDRA = DDRA | 1<<DDA0;  // D0 as output
  */
  DDRA=0xff;
  DDRC = DDRC & ~(1<<DDC6);  // disable back light
  //IO0DIR_bit.P0_25 = 1;  // EL2 as output
  //IO0DIR_bit.P0_23 = 1;  // EL1 as output

}


// Turn ON LCD
void LCD_On() {

  volatile unsigned int i = 0;
  
  // delay
 // for(i=0; i<65534; i++);
//	EN_ON;
  
  // delay	30534 - old
  for(i=0; i<lcd_delay; i++);
  VHH_ON;

  // delay
  for(i=0; i<lcd_delay; i++);
  DISP_ON;

  // delay
  for(i=0; i<lcd_delay; i++);

}

// Turn OFF LCD
void LCD_Off(){

  volatile unsigned int i = 0;

  // delay
  for(i=0; i<lcd_delay; i++);

  DISP_OFF;

  // delay
  for(i=0; i<lcd_delay; i++);

  VHH_OFF;

  // delay
  for(i=0; i<lcd_delay; i++);

 // EN_OFF;
	// delay
 // for(i=0; i<65534; i++);
 
}


// Set backlight
/*
void SetBackLight(unsigned char light) {

  if(light == LIGHT_OFF) {
    EL1_LOW;
    EL2_LOW;
  }
  else if(light == LIGHT_GREEN) {
    EL1_LOW;
    EL2_HIGH;
  }
  else if(light == LIGHT_YELLOW) {
    EL2_LOW;
    EL1_HIGH;
  }
  else {
    EL1_LOW;
    EL2_LOW;
  }

}
*/

/*
// Write bitmap array
// array is global defined -> unsigned char bitmap[160*20];
// Array contains 160*20 char symbol -> 160x160 bits!
void LCDWriteBitmap(void) {

  // variable for loop cycle
  unsigned int i = 0;
  unsigned int j = 0;

  // loop for every row
  // for(i=20; i<(160*20); i+=20) {
  for(i=0; i<(3200); i+=20) {
    // loop for every col
    for(j=0; j<20; j++) {

      // get data
      unsigned char pl = bitmap[i+j];
      unsigned char ph = pl>>4;
      pl &= 0xF;

      //IO0CLR = 0x001E0000;
      //IO0SET = LookUpSet[ph];
      
	  // clock CP
      //IO0CLR = BIT21; - do it with OC1C

      //IO0CLR = 0x001E0000;
      //IO0SET = LookUpSet[pl];
      
	  // clock CP
      //IO0CLR = BIT21; - do it with OC1C
    }

    if(i)
    {
      LP_HIGH;
      LP_LOW;
    }
    else
    {
      // start new frame
      // for every new frame
      FLM_HIGH;
      LP_HIGH;
      LP_LOW;
      FLM_LOW;
    }
  }

  LP_HIGH;
  LP_LOW;
}


*/
//Blank screen***************************************************

void LCDWriteBlank(void){

for(int i=0; i<(3200); i+=20) {
    // loop for every col
    for(int j=0; j<20; j++) {
		bitmap[i+j]=0;
	}	
}
	
}

// Write char to LCD at specify position
// x, y is coordinate
// invert is 0 or 1 - invert text
void LCDWriteChar(int nmb,int pos,int x, int y, char ch, char invert) {
		#if 0
		 //PGM_P p;
		switch(nmb){
			case 0:	memcpy_P(myrow[pos], &FontLookup[ch-32][0], 8);
	    		break;
			case 1:	memcpy_P(myrow2[pos], &FontLookup[ch-32][0], 8);
	    		break;
			case 2:	memcpy_P(myrow3[pos], &FontLookup[ch-32][0], 8);
	    		break;
			case 3:	memcpy_P(myrow4[pos], &FontLookup[ch-32][0], 8);
	    		break;
			case 4:	memcpy_P(myrow5[pos], &FontLookup[ch-32][0], 8);
	    		break;
			case 5:	memcpy_P(myrow6[pos], &FontLookup[ch-32][0], 8);
	    		break;
			case 6:	memcpy_P(myrow7[pos], &FontLookup[ch-32][0], 8);
    			break;
			case 7:	memcpy_P(myrow8[pos], &FontLookup[ch-32][0], 8);
    			break;
			case 8:	memcpy_P(myrow9[pos], &FontLookup[ch-32][0], 8);
    			break;
			case 9:	memcpy_P(myrow10[pos], &FontLookup[ch-32][0], 8);
    			break;
			//case 5:	memcpy_P(myrow6[pos], &FontLookup[ch-32][0], 8);
    			//break;
		}// END of switch
	#endif
	
		#if 1
		  if(!invert) {
		    memcpy_P(&bitmap[(x+1)*20+y],&FontLookup[ch-32][0],1);//bitmap[(x+1)*20+y] = FontLookup[ch-32][0];
		    memcpy_P(&bitmap[(x+2)*20+y],&FontLookup[ch-32][1],1);//bitmap[(x+2)*20+y] = FontLookup[ch-32][1];
		    memcpy_P(&bitmap[(x+3)*20+y],&FontLookup[ch-32][2],1);//bitmap[(x+3)*20+y] = FontLookup[ch-32][2];
		    memcpy_P(&bitmap[(x+4)*20+y],&FontLookup[ch-32][3],1);//bitmap[(x+4)*20+y] = FontLookup[ch-32][3];
		    memcpy_P(&bitmap[(x+5)*20+y],&FontLookup[ch-32][4],1);//bitmap[(x+5)*20+y] = FontLookup[ch-32][4];
		    memcpy_P(&bitmap[(x+6)*20+y],&FontLookup[ch-32][5],1);//bitmap[(x+6)*20+y] = FontLookup[ch-32][5];
		    memcpy_P(&bitmap[(x+7)*20+y],&FontLookup[ch-32][6],1);//bitmap[(x+7)*20+y] = FontLookup[ch-32][6];
		    memcpy_P(&bitmap[(x+8)*20+y],&FontLookup[ch-32][7],1);//bitmap[(x+8)*20+y] = FontLookup[ch-32][7];
		  }
		  else {
		    memcpy_Pinv(&bitmap[(x+1)*20+y],&FontLookup[ch-32][0],1);//bitmap[(x+1)*20+y] = ~FontLookup[ch-32][0];
		    memcpy_Pinv(&bitmap[(x+2)*20+y],&FontLookup[ch-32][1],1);//bitmap[(x+2)*20+y] = ~FontLookup[ch-32][1];
		    memcpy_Pinv(&bitmap[(x+3)*20+y],&FontLookup[ch-32][2],1);//bitmap[(x+3)*20+y] = ~FontLookup[ch-32][2];
		    memcpy_Pinv(&bitmap[(x+4)*20+y],&FontLookup[ch-32][3],1);//bitmap[(x+4)*20+y] = ~FontLookup[ch-32][3];
		    memcpy_Pinv(&bitmap[(x+5)*20+y],&FontLookup[ch-32][4],1);//bitmap[(x+5)*20+y] = ~FontLookup[ch-32][4];
		    memcpy_Pinv(&bitmap[(x+6)*20+y],&FontLookup[ch-32][5],1);//bitmap[(x+6)*20+y] = ~FontLookup[ch-32][5];
		    memcpy_Pinv(&bitmap[(x+7)*20+y],&FontLookup[ch-32][6],1);//bitmap[(x+7)*20+y] = ~FontLookup[ch-32][6];
		    memcpy_Pinv(&bitmap[(x+8)*20+y],&FontLookup[ch-32][7],1);//bitmap[(x+8)*20+y] = ~FontLookup[ch-32][7];

		  }
		#endif
}

/*
// Refresh
// its very expiremental - nees information
void Refresh(void) {

}


// Write string
// at specify position
// inv - inverted text
void LCDWriteString(int row, int pos, unsigned char* arr, int inv) {

  unsigned int i = pos;

  while((*arr) != '\0') {

    LCDWriteChar(row, i, (*arr), inv);

    i++;
    arr++;

  }

}

*/

// get adc value from X coordinate
/*
unsigned int GetY_value(void) {

  // first function for P0.28 and P0.30
  PINSEL1_bit.P0_28 = 0;
  PINSEL1_bit.P0_30 = 0;

  IO0SET_bit.P0_28 = 1;  // P0.28 to high
  IO0CLR_bit.P0_30 = 1;  // P0.30 to low

  IO0DIR_bit.P0_28 = 1;  // P0.28 as output
  IO0DIR_bit.P0_30 = 1;  // P0.30 as output

  // free pin
  IO0CLR_bit.P0_29 = 1;  // P0.29 to low
  IO0DIR_bit.P0_29 = 0;  // P0.29 as input


  return ( MeasureADCChanel(1) >> 9) & 0xFFF;

}
*/

// get adc value Y coordinate
/*
unsigned int GetX_value(void) {

  // first function for P0.28 and P0.30
  PINSEL1_bit.P0_27 = 0;
  PINSEL1_bit.P0_29 = 0;

  IO0SET_bit.P0_27 = 1;  // P0.28 to high
  IO0CLR_bit.P0_29 = 1;  // P0.30 to low

  IO0DIR_bit.P0_27 = 1;  // P0.28 as output
  IO0DIR_bit.P0_29 = 1;  // P0.30 as output

  // free pin
  IO0CLR_bit.P0_30 = 1;  // P0.29 to low
  IO0DIR_bit.P0_30 = 0;  // P0.29 as input


   return ( MeasureADCChanel(2) >> 9) & 0xFFF;
}
*/
